from bitarray import bitarray


def do_bit_stuffing(unstuffed_ba: bitarray, break_symbol: int = 1, break_every: int = 5) -> bitarray:
    stuffed_ba = bitarray()
    streak = 0
    for idx, bit in enumerate(unstuffed_ba):
        stuffed_ba.append(bit)
        if bit == break_symbol:
            streak += 1
            if streak >= break_every:
                stuffed_ba.append(not bit)
                streak = 0
        else:
            streak = 0
    return stuffed_ba


def reverse_bit_stuffing(stuffed_ba: bitarray, break_symbol: int = 1, break_every: int = 5) -> bitarray:
    unstuffed_ba = bitarray()
    streak = 0
    for bit in stuffed_ba:
        if streak == break_every:
            streak = 0
            continue
        unstuffed_ba.append(bit)
        if bit == break_symbol:
            streak += 1
        else:
            streak = 0
    return unstuffed_ba


def do_nrzi_encoding(normal_ba: bitarray, start_symbol: int = 1) -> bitarray:
    nrzi_ba = bitarray()
    nrzi_bit = start_symbol
    for bit in normal_ba:
        if bit == 0:
            nrzi_bit ^= 1
        nrzi_ba.append(nrzi_bit)
    return nrzi_ba


def reverse_nrzi_encoding(nrzi_ba: bitarray, start_symbol: int = 1) -> bitarray:
    normal_ba = bitarray()
    last_bit = start_symbol
    for bit in nrzi_ba:
        normal_ba.append(1 if (bit == last_bit) else 0)
        last_bit = bit
    return normal_ba


def reverse_bits(byte: int) -> int:
    return int('{:08b}'.format(byte)[::-1], 2)
